; 
    include \masm32\include\masm32rt.inc
    include \masm32\macros\timers.asm

;    [url=http://www.masm32.com/board/index.php?topic=1807.msg80884#msg80884]Lingo, 6.3.2009[/url]

    LOOP_COUNT	= 1000000
    SLEEP_MS	= 3000

    .686
    .mmx
    .xmm

    lstrlenA PROTO:DWORD
    AzmtStrLen1A PROTO:DWORD
    AzmtStrLen2A PROTO:DWORD

    markl_szlen PROTO:DWORD
    StrSizeA PROTO :DWORD
    StringLength_Mmx_Min PROTO :DWORD
    _strlen PROTO :DWORD

; 
    .data
      szTest_0 db "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl",\
                  0,0,0,0

      align 16
      szTest_1k	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother darryl my other brother darryl "
	db "my other brother", 0
      align 16
      db 0
      szTest_1 db "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl",\
                  0,0,0,0
      align 16
      dd 0
      szTest_4 db "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl",\
                  0,0,0,0

      align 16
      db 7 dup (0)
      szTest_7 db "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl ",\
                  "my other brother darryl my other brother darryl",\
                  0,0,0,0      

      
    .code
; 
start:
; 

    szTest TEXTEQU <szTest_1k>

    invoke lstrlenA, ADDR szTest
    push  eax
    print "lstrlenA return value     : "
    pop   eax
    print ustr$(eax),13,10

     lea ecx, szTest
	call strlen64
    push  eax
    print "strlen64Lingo return value: "
    pop   eax
    print ustr$(eax),13,10

    invoke AzmtStrLen1A, ADDR szTest
    push  eax
    print "AzmtStrLen1A return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke AzmtStrLen2A, ADDR szTest
    push  eax
    print "AzmtStrLen2A return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke markl_szlen, ADDR szTest
    push  eax
    print "markl_szlen return value  : "
    pop   eax
    print ustr$(eax),13,10

    invoke StringLength_Mmx_Min, ADDR szTest
    push  eax
    print "StringLength_Mmx_Min",10,13,"(MMX/SSE2) return value   : "
    pop   eax
    print ustr$(eax),13,10

    invoke StrSizeA, ADDR szTest
    push  eax
    print "StrSizeA(SSE2) value      : "
    pop   eax
    print ustr$(eax),13,10

    invoke _strlen, ADDR szTest
    push  eax
    print "_strlen return value      : "
    pop   eax
    print ustr$(eax),13,10,13,10

    invoke Sleep, SLEEP_MS

    FOR _sz, <szTest_1k, szTest_0, szTest_1, szTest_4, szTest_7>
;         szCnt = @SizeStr(<&_sz>)
;         txt SUBSTR <&_sz>,szCnt
         txt SUBSTR <_sz>, 8
         txt TEXTEQU <"align >,txt,<">
   %     print txt,10,13,10,13

    invoke lstrlenA, ADDR _sz
    push  eax
    print "lstrlenA return value: "
    pop   eax
    print ustr$(eax),13,10

        print "lstrlenA      :       "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
          invoke lstrlenA, ADDR _sz
        counter_end
        print ustr$(eax)," cycles",13,10
    
        print "strlen64Lingo :       "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
     lea ecx, szTest
	call strlen64
        counter_end
        print ustr$(eax)," cycles",13,10


        print "AzmtStrLen1A  :       "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
          invoke AzmtStrLen1A, ADDR _sz
        counter_end
        print ustr$(eax)," cycles",13,10
    
        print "AzmtStrLen2A  :       "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
          invoke AzmtStrLen2A, ADDR _sz
        counter_end
        print ustr$(eax)," cycles",13,10
    
        print "markl_szlen   :       "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
          invoke markl_szlen, ADDR _sz
        counter_end
        print ustr$(eax)," cycles",13,10
    
       print "StringLength_Mmx_Min: "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
          invoke StringLength_Mmx_Min, ADDR _sz
        counter_end
        print ustr$(eax)," cycles",13,10
    
        print "StrSizeA(SSE2):       "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
          invoke StrSizeA, ADDR _sz
        counter_end
        print ustr$(eax)," cycles",13,10
    
        print "_strlen (Agner Fog):  "
        counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
          invoke _strlen, ADDR _sz
        counter_end
        print ustr$(eax)," cycles",13,10,13,10
    ENDM

    ; inkey "Press any key to exit..."
    exit

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
DB 4 DUP (90h)

;
; Returns the string length in EAX and pointer in EDX.
;
; p_lpszStr : Pointer to the string.
;
AzmtStrLen1A PROC p_lpszStr:DWORD

    mov edx, dword ptr [esp+4]
    xor eax, eax

@@:
    mov ecx, dword ptr [edx+eax]
    add eax, 16
    test ecx, 0FFh
    jz @0
    test ecx, 0FF00h
    jz @1
    test ecx, 0FF0000h
    jz @2
    test ecx, 0FF000000h
    jz @3
    mov ecx, dword ptr [edx+eax-12]
    test ecx, 0FFh
    jz @4
    test ecx, 0FF00h
    jz @5
    test ecx, 0FF0000h
    jz @6
    test ecx, 0FF000000h
    jz @7
    mov ecx, dword ptr [edx+eax-8]
    test ecx, 0FFh
    jz @8
    test ecx, 0FF00h
    jz @9
    test ecx, 0FF0000h
    jz @10
    test ecx, 0FF000000h
    jz @11
    mov ecx, dword ptr [edx+eax-4]
    test cl, cl
    jz @12
    test ecx, 0FF00h
    jz @13
    test ecx, 0FF0000h
    jz @14
    test ecx, 0FF000000h
    jnz @B

    sub eax, 1
    ret 4

@0:
    sub eax, 16
    ret 4

@1:
    sub eax, 15
    ret 4

@2:
    sub eax, 14
    ret 4

@3:
    sub eax, 13
    ret 4

@4:
    sub eax, 12
    ret 4

@5:
    sub eax, 11
    ret 4

@6:
    sub eax, 10
    ret 4

@7:
    sub eax, 9
    ret 4

@8:
    sub eax, 8
    ret 4

@9:
    sub eax, 7
    ret 4

@10:
    sub eax, 6
    ret 4

@11:
    sub eax, 5
    ret 4

@12:
    sub eax, 4
    ret 4

@13:
    sub eax, 3
    ret 4

@14:
    sub eax, 2
    ret 4

AzmtStrLen1A ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ALIGN 16
DB 4 DUP (90h)

;
; Returns the string length in EAX and pointer in EDX.
;
; p_lpszStr : Pointer to the string.
;
AzmtStrLen2A PROC p_lpszStr:DWORD

    mov edx, dword ptr [esp+4]
    xor eax, eax

@@:
    mov ecx, dword ptr [edx+eax]
    add eax, 16
    test cl, cl
    jz @0
    test ch, ch
    jz @1
    test ecx, 0FF0000h
    jz @2
    test ecx, 0FF000000h
    jz @3
    mov ecx, dword ptr [edx+eax-12]
    test cl, cl
    jz @4
    test ch, ch
    jz @5
    test ecx, 0FF0000h
    jz @6
    test ecx, 0FF000000h
    jz @7
    mov ecx, dword ptr [edx+eax-8]
    test cl, cl
    jz @8
    test ch, ch
    jz @9
    test ecx, 0FF0000h
    jz @10
    test ecx, 0FF000000h
    jz @11
    mov ecx, dword ptr [edx+eax-4]
    test cl, cl
    jz @12
    test ch, ch
    jz @13
    test ecx, 0FF0000h
    jz @14
    test ecx, 0FF000000h
    jnz @B

    sub eax, 1
    ret 4

@0:
    sub eax, 16
    ret 4

@1:
    sub eax, 15
    ret 4

@2:
    sub eax, 14
    ret 4

@3:
    sub eax, 13
    ret 4

@4:
    sub eax, 12
    ret 4

@5:
    sub eax, 11
    ret 4

@6:
    sub eax, 10
    ret 4

@7:
    sub eax, 9
    ret 4

@8:
    sub eax, 8
    ret 4

@9:
    sub eax, 7
    ret 4

@10:
    sub eax, 6
    ret 4

@11:
    sub eax, 5
    ret 4

@12:
    sub eax, 4
    ret 4

@13:
    sub eax, 3
    ret 4

@14:
    sub eax, 2
    ret 4

AzmtStrLen2A ENDP

OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF

; 
; Author:           [url=http://www.agner.org/optimize/asmexamples.zip]Agner Fog[/url]
; Date created:     2008-07-06
; Last modified:    2008-07-06

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
_strlen proc src:DWORD
        mov      eax,  [esp+4]         ; get pointer to string
        mov      ecx,  eax             ; copy pointer
        pxor     xmm0, xmm0            ; set to zero
        and      ecx,  15              ; lower 4 bits indicate misalignment
        and      eax,  -16             ; align pointer by 16
	if 0
		movaps   xmm1, [eax]           ; read from nearest preceding boundary
	else
		movdqa   xmm1, [eax]           ; read from nearest preceding boundary
	endif
        pcmpeqb  xmm1, xmm0            ; compare 16 bytes with zero
        pmovmskb edx,  xmm1            ; get one bit for each byte result
        shr      edx,  cl              ; shift out false bits
        shl      edx,  cl              ; shift back again
        bsf      edx,  edx             ; find first 1-bit
        jnz      L2                    ; found
        
        ; Main loop, search 16 bytes at a time
L1:     add      eax,  16              ; increment pointer by 16
	if 0
		movaps   xmm1, [eax]           ; read 16 bytes aligned
	else
		movdqa   xmm1, [eax]           ; read 16 bytes aligned
	endif
        pcmpeqb  xmm1, xmm0            ; compare 16 bytes with zero
        pmovmskb edx,  xmm1            ; get one bit for each byte result
        bsf      edx,  edx             ; find first 1-bit
        jz       L1                    ; loop if not found
        
L2:     ; Zero-byte found. Compute string length        
        sub      eax,  [esp+4]         ; subtract start address
        add      eax,  edx             ; add byte index
        ret 4       
_strlen endp


ALIGN 16
DB 4 DUP (90h)

markl_szlen proc pString:DWORD

    push ebx
    push esi

    mov esi, [esp+12]

    ;------------------------------------------
    ; Special handling for zero-length string.
    ;------------------------------------------

    mov eax, [esi]
    or  eax, eax
    jz  fini
  @@:
    mov eax, [esi]
    mov ebx, [esi+4]
    mov ecx, [esi+8]
    mov edx, [esi+12]
    add esi, 16
    and eax, 0ff000000h
    jz  dw0
    and ebx, 0ff000000h
    jz  dw1
    and ecx, 0ff000000h
    jz  dw2
    and edx, 0ff000000h
    jz  dw3
    jmp @B
 dw0:
    sub esi, 4
 dw1:
    sub esi, 4
 dw2:
    sub esi, 4
 dw3:
    sub esi, 4
    cmp BYTE PTR [esi],0
    je  @F
    inc esi
    jmp @B
 @@:   
    sub esi, [esp+12]
    mov eax, esi
 fini:
    pop esi
    pop ebx

    ret 4

markl_szlen endp


align 16	
StrSizeA proc lpStrA:DWORD
	
@@:	mov edx,DWORD ptr [esp+4]
	pxor xmm1,xmm1
	mov ecx,edx
      neg ecx
      align 16
@@:	movdqu xmm0,OWORD ptr [edx] 
      lea edx,[edx+16]	
      pcmpeqb xmm0,xmm1
      pmovmskb eax,xmm0
	test eax,eax	
      jz @B 

@@:	lea ecx,[edx+ecx-16]
      xor edx,edx
      bsf edx,eax
	lea eax,[ecx+edx]
	ret 4

StrSizeA endp

align 16
StringLength_Mmx_Min proc lpStr:DWORD

    mov eax,DWORD ptr [esp+4]
    mov ecx,eax
    pxor MM0,MM0
    Label1: pcmpeqb MM0,QWORD PTR [eax]
    pmovmskb edx,MM0
    add eax,8
    test edx,edx
    jz Label1
    sub eax,ecx
    bsf edx,edx
    lea eax,[eax+edx-8]
     
    ret 4
StringLength_Mmx_Min endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

strlen64:
		pxor		xmm0,	xmm0	
		pxor		xmm1,	xmm1
		pcmpeqb	xmm0,	[ecx]	        ; rcx
		pcmpeqb	xmm1,	[ecx+16]      ; rcx+16  
		por		xmm1,	xmm0							
		pmovmskb	eax,		xmm1					
		test		eax,		eax				
		je		@f	
		pmovmskb	ecx,		xmm0
		shl		eax,		16
		or		eax,		ecx
		bsf		eax,		eax	
		ret
align 16
@@:
		pcmpeqb	xmm0,	[ecx+eax+32]	; rcx+rax+32
		pcmpeqb	xmm1,	[ecx+eax+48]    ;rcx+rax+48   
		por		xmm1,	xmm0							
		pmovmskb	edx,		xmm1					
		add		eax,		32		
		test		edx,		edx								
		jz		@b	
		pmovmskb	ecx,		xmm0
		shl		edx,		16
		or		edx,		ecx
		bsf		edx,		edx	
		add		eax,		edx
		ret



; 

end start

OPT_Assembler	JWasm
OPT_Res	0
OPT_Tmp2Asm	1
